package com.hotwj.platform.driverManagement.driverSkillAssessment.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.driverManagement.driver.domain.vo.HotDriverVo;
import com.hotwj.platform.driverManagement.driver.service.IHotDriverService;
import com.hotwj.platform.driverManagement.driverSkillAssessment.domain.HotDriverSkillAssessment;
import com.hotwj.platform.driverManagement.driverSkillAssessment.domain.bo.HotDriverSkillAssessmentBo;
import com.hotwj.platform.driverManagement.driverSkillAssessment.domain.vo.HotDriverSkillAssessmentVo;
import com.hotwj.platform.driverManagement.driverSkillAssessment.mapper.HotDriverSkillAssessmentMapper;
import com.hotwj.platform.driverManagement.driverSkillAssessment.service.IHotDriverSkillAssessmentService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 驾驶员技能考核（明细项）Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-16
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotDriverSkillAssessmentServiceImpl implements IHotDriverSkillAssessmentService {

    private final HotDriverSkillAssessmentMapper baseMapper;
    private final IHotDriverService driverService;

    /**
     * 查询驾驶员技能考核（明细项）
     *
     * @param id 主键
     * @return 驾驶员技能考核（明细项）
     */
    @Override
    public HotDriverSkillAssessmentVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询驾驶员技能考核（明细项）列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 驾驶员技能考核（明细项）分页列表
     */
    @Override
    public TableDataInfo<HotDriverSkillAssessmentVo> queryPageList(HotDriverSkillAssessmentBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotDriverSkillAssessment> lqw = buildQueryWrapper(bo);
        Page<HotDriverSkillAssessmentVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的驾驶员技能考核（明细项）列表
     *
     * @param bo 查询条件
     * @return 驾驶员技能考核（明细项）列表
     */
    @Override
    public List<HotDriverSkillAssessmentVo> queryList(HotDriverSkillAssessmentBo bo) {
        LambdaQueryWrapper<HotDriverSkillAssessment> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotDriverSkillAssessment> buildQueryWrapper(HotDriverSkillAssessmentBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotDriverSkillAssessment> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotDriverSkillAssessment::getId);
        lqw.eq(bo.getCompanyId() != null, HotDriverSkillAssessment::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getDriverId() != null, HotDriverSkillAssessment::getDriverId, bo.getDriverId());
        lqw.eq(StringUtils.isNotBlank(bo.getPermittedVehicleType()), HotDriverSkillAssessment::getPermittedVehicleType, bo.getPermittedVehicleType());
        lqw.eq(StringUtils.isNotBlank(bo.getExamVehicleModel()), HotDriverSkillAssessment::getExamVehicleModel, bo.getExamVehicleModel());
        lqw.eq(bo.getAssessDate() != null, HotDriverSkillAssessment::getAssessDate, bo.getAssessDate());
        lqw.eq(StringUtils.isNotBlank(bo.getExamRoute()), HotDriverSkillAssessment::getExamRoute, bo.getExamRoute());
        lqw.eq(StringUtils.isNotBlank(bo.getDrivingExperience()), HotDriverSkillAssessment::getDrivingExperience, bo.getDrivingExperience());
        lqw.eq(StringUtils.isNotBlank(bo.getDrivingMileage()), HotDriverSkillAssessment::getDrivingMileage, bo.getDrivingMileage());
        lqw.eq(StringUtils.isNotBlank(bo.getExamContent()), HotDriverSkillAssessment::getExamContent, bo.getExamContent());
        lqw.eq(StringUtils.isNotBlank(bo.getChiefExaminerSignature()), HotDriverSkillAssessment::getChiefExaminerSignature, bo.getChiefExaminerSignature());
        lqw.eq(StringUtils.isNotBlank(bo.getInvigilatorSignature()), HotDriverSkillAssessment::getInvigilatorSignature, bo.getInvigilatorSignature());
        lqw.eq(StringUtils.isNotBlank(bo.getChiefOpinion()), HotDriverSkillAssessment::getChiefOpinion, bo.getChiefOpinion());
        lqw.eq(StringUtils.isNotBlank(bo.getInvigilatorOpinion()), HotDriverSkillAssessment::getInvigilatorOpinion, bo.getInvigilatorOpinion());
        lqw.eq(StringUtils.isNotBlank(bo.getCompanyLeaderOpinion()), HotDriverSkillAssessment::getCompanyLeaderOpinion, bo.getCompanyLeaderOpinion());
        lqw.eq(bo.getIsDeleted() != null, HotDriverSkillAssessment::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增驾驶员技能考核（明细项）
     *
     * @param bo 驾驶员技能考核（明细项）
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotDriverSkillAssessmentBo bo) {
        HotDriverSkillAssessment add = MapstructUtils.convert(bo, HotDriverSkillAssessment.class);
        // 填充驾驶员名称
        if (StringUtils.isNotBlank(add.getDriverId())) {
            HotDriverVo driver = driverService.queryById(add.getDriverId());
            if (driver != null) {
                add.setDriverName(driver.getName());
            }
        }
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改驾驶员技能考核（明细项）
     *
     * @param bo 驾驶员技能考核（明细项）
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotDriverSkillAssessmentBo bo) {
        HotDriverSkillAssessment update = MapstructUtils.convert(bo, HotDriverSkillAssessment.class);
        // 填充驾驶员名称
        if (StringUtils.isNotBlank(update.getDriverId())) {
            HotDriverVo driver = driverService.queryById(update.getDriverId());
            if (driver != null) {
                update.setDriverName(driver.getName());
            }
        }
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotDriverSkillAssessment entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除驾驶员技能考核（明细项）信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
